from PyQt4.QtCore import *
from PyQt4.QtGui import *

class ModelBase(QObject):
    baseSignal = pyqtSignal()
    
    def __init__(self, parent):
        QObject.__init__(self, parent)
    
    @pyqtSlot()
    def baseSlot(self):
        print 'baseSlot called'
    
    @pyqtSlot()
    def onModelReset(self):
        print 'onModelReset called'
        
class AModel(ModelBase, QAbstractItemModel):
    aSignal = pyqtSignal()
    
    def __init__(self, parent=None):
        QAbstractItemModel.__init__(self, parent)
        ModelBase.__init__(self, parent)
    
    @pyqtSlot()
    def aSlot(self):
        print 'aSlot called'

class BModel(ModelBase, QAbstractTableModel):
    bSignal = pyqtSignal()
    
    def __init__(self, parent=None):
        QAbstractTableModel.__init__(self, parent)
        ModelBase.__init__(self, parent)
    
    @pyqtSlot()
    def bSlot(self):
        print 'bSlot called'
    
app = QApplication([])
a = AModel()
b = BModel()
a.baseSignal.connect(a.baseSlot)
a.baseSignal.emit()
b.bSignal.connect(b.bSlot)
b.bSignal.connect(b.baseSlot)
b.bSignal.emit()
print a.modelReset
#a.modelReset.connect(a.onModelReset)

